<div class="panel-group" id="accordion" role="tablist" aria-multiselectable="true">

    <!-- LayerScript -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="layerScriptH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#layerScript"
                   aria-expanded="true" aria-controls="layerScript">
                    Layer Script
                </a>
            </h4>
        </div>
        <div id="layerScript" class="panel-collapse collapse in" aria-expanded="true" role="tabpanel"
             aria-labelledby="layerScriptH">
            <div class="panel-body">

                <p>Sie knnen im Backend von <a href='https://app.doofinder.com/admin/'>doofinder.com</a> den
                    Assistenten verwenden, um
                    ein Layer-Script zu erstellen.</p>
                <p>Den Assistenten finden Sie unter: <code>Installation Scripts &gt; Doofinder Layer &gt; Configure
                        Doofinder
                        Layer</code></p>
                <p>Bitte ersetzen Sie im erstellten Skript die HashID, Sprache und Whrung durch die folgenden
                    Platzhalter:</p>
                <ul>
                    <li>Hash ID : <strong>###HASHID###</strong> <em>(z.B. a1b2c3d4e5f6a1b2c3d4e5f6a1b2c3d4)</em></li>
                    <li>Sprache : <strong>###LANG###</strong> <em>(z.B. de)</em></li>
                    <li>Whrung : <strong>###CURR###</strong> <em>(z.B. EUR)</em></li>
                </ul>
                <p>Die Hash IDs knnen Sie im Reiter <a href="#plugin-tab-{$kAdminMenuWD}" data-toggle="tab" role="tab">Weitere
                        Datenfeeds</a>
                    pflegen</p>


                <form method="post" action='?kPlugin={$oPlugin->kPlugin}'>
                    <input type="hidden" name="action" value="save"/>
                    <input type="hidden" name="setting" value="layerScript"/>
                    <div class="form-group">
                        <label for="doofinderLayerInput">Doofinder Layer</label>
                        <textarea style="height: 400px;" name="content" class="form-control"
                                  id="doofinderLayerInput">{$DFSettings['layerScript']->cContent|htmlentities}</textarea>
                    </div>
                    <button type="submit" class="btn btn-default">Speichern</button>
                </form>

            </div>
        </div>
    </div>

    <!-- Custom Template -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="customTemplateH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#customTemplate"
                   aria-expanded="false" aria-controls="customTemplate">
                    Custom Results-Template
                </a>
            </h4>
        </div>
        <div id="customTemplate" class="panel-collapse collapse" role="tabpanel" aria-labelledby="customTemplateH">
            <div class="panel-body">

                <p>Um dieses Template zu verwenden, mssen Sie das LayerScript anpassen, z.B.: (<a
                            href='https://www.doofinder.com/support/developer/layer/doofinder-classic-layer#template_1'
                            target='_blank'>doofinder
                        Dokumentation</a>)</p>
                <pre>
&nbsp;&nbsp;"display": {ldelim}
&nbsp;&nbsp;&nbsp;&nbsp;"results": {ldelim}
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"template": document.getElementById('df-results-template').innerHTML
&nbsp;&nbsp;&nbsp;&nbsp;{rdelim}
&nbsp;&nbsp;{rdelim}
</pre>
                <p>Die Standard-Daten, die im Template Verfgbar sind, sehen Sie hier: <a
                            href="https://www.doofinder.com/support/developer/layer/doofinder-classic-layer#transformer">Transformer</a>.<br/>
                    Um mehrere Daten anzuzeigen, mssen Sie dem LayerScript folgendes hinzufgen:</p>
                <pre>
  searchParams: {ldelim}
    transformer: null
  {rdelim}
</pre>
                <p>Daten die z.B. <code>&amp;euro;</code> enthalten, knnen Sie mit <code>&</code>, z.B. <code>{ldelim}
                        {ldelim}
                        &base_price_localized.0{rdelim}{rdelim}</code> formatieren.</p>
                <form method="post" action='?kPlugin={$oPlugin->kPlugin}&action=save&setting=customTPL'>
                    <div class="form-group">
        <textarea style="height: 400px;" name="content" class="form-control"
                  id="doofinderTPLInput">{$DFSettings['customTPL']->cContent|htmlentities}</textarea>
                    </div>
                    <button type="submit" class="btn btn-default">Speichern</button>
                    <a onclick="return confirm('Wirklich zurcksetzen? Deine nderungen gehen dabei verloren!')"
                       href="?kPlugin={$oPlugin->kPlugin}&action=reset&setting=customTPL" class="btn btn-danger">zurcksetzen</a>
                </form>
            </div>
        </div>
    </div>

    <!-- Desktop Template -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="customDesktopTemplateH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#customDesktopTemplate"
                   aria-expanded="false" aria-controls="customDesktopTemplate">
                    Custom Desktop-Template
                </a>
            </h4>
        </div>
        <div id="customDesktopTemplate" class="panel-collapse collapse" role="tabpanel"
             aria-labelledby="customDesktopTemplateH">
            <div class="panel-body">

                <p>Um dieses Template zu verwenden, mssen Sie das LayerScript anpassen, z.B.: (<a
                            href='https://www.doofinder.com/support/developer/layer/doofinder-classic-layer#template'
                            target='_blank'>doofinder
                        Dokumentation</a>)</p>
                <pre>
{ldelim}
  display: {rdelim}
    template: document.getElementById('df-layer-template').innerHTML
  {ldelim}
{ldelim}
</pre>
                <p>Daten die z.B. <code>&amp;euro;</code> enthalten, knnen Sie mit <code>&</code>, z.B. <code>{ldelim}
                        {ldelim}
                        &base_price_localized.0{rdelim}{rdelim}</code> formatieren.</p>
                <form method="post" action='?kPlugin={$oPlugin->kPlugin}&action=save&setting=desktopTPL'>
                    <div class="form-group">
        <textarea style="height: 400px;" name="content" class="form-control"
                  id="doofinderTPLInput">{$DFSettings['desktopTPL']->cContent|htmlentities}</textarea>
                    </div>
                    <button type="submit" class="btn btn-default">Speichern</button>
                    <a onclick="return confirm('Wirklich zurcksetzen? Deine nderungen gehen dabei verloren!')"
                       href="?kPlugin={$oPlugin->kPlugin}&action=reset&setting=desktopTPL" class="btn btn-danger">zurcksetzen</a>
                </form>

            </div>
        </div>
    </div>

    <!-- Mobile Template -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="customMobileTemplateH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#customMobileTemplate"
                   aria-expanded="false" aria-controls="customMobileTemplate">
                    Custom Mobile-Template
                </a>
            </h4>
        </div>
        <div id="customMobileTemplate" class="panel-collapse collapse" role="tabpanel"
             aria-labelledby="customMobileTemplateH">
            <div class="panel-body">

                <p>Um dieses Template zu verwenden, mssen Sie das LayerScript anpassen, z.B.: (<a
                            href='https://www.doofinder.com/support/developer/layer/doofinder-classic-layer#template_3'
                            target='_blank'>doofinder
                        Dokumentation</a>)</p>
                <pre>
"mobile": {ldelim}
&nbsp;&nbsp;"display": {ldelim}
&nbsp;&nbsp;&nbsp;&nbsp;"template": document.getElementById('df-mobile-template').innerHTML
&nbsp;&nbsp;{rdelim}
{rdelim}
</pre>
                <p>Daten die z.B. <code>&amp;euro;</code> enthalten, knnen Sie mit <code>&</code>, z.B. <code>{ldelim}
                        {ldelim}
                        &base_price_localized.0{rdelim}{rdelim}</code> formatieren.</p>
                <form method="post" action='?kPlugin={$oPlugin->kPlugin}&action=save&setting=mobileTPL'>
                    <div class="form-group">
        <textarea style="height: 400px;" name="content" class="form-control"
                  id="doofinderTPLInput">{$DFSettings['mobileTPL']->cContent|htmlentities}</textarea>
                    </div>
                    <button type="submit" class="btn btn-default">Speichern</button>
                    <a onclick="return confirm('Wirklich zurcksetzen? Deine nderungen gehen dabei verloren!')"
                       href="?kPlugin={$oPlugin->kPlugin}&action=reset&setting=mobileTPL" class="btn btn-danger">zurcksetzen</a>
                </form>

            </div>
        </div>
    </div>

    <!-- CSS Anpassungen -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="cssModificationH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#cssModification"
                   aria-expanded="false" aria-controls="cssModification">
                    CSS Anpassungen
                </a>
            </h4>
        </div>
        <div id="cssModification" class="panel-collapse collapse" role="tabpanel" aria-labelledby="cssModificationH">
            <div class="panel-body">

                <form method="post" action='?kPlugin={$oPlugin->kPlugin}&action=save&setting=customCSS'>
                    <div class="form-group">
        <textarea style="height: 400px;" name="content" class="form-control"
                  id="doofinderCSSInput">{$DFSettings['customCSS']->cContent|htmlentities}</textarea>
                    </div>
                    <button type="submit" class="btn btn-default">Speichern</button>
                    <a onclick="return confirm('Wirklich zurcksetzen? Deine nderungen gehen dabei verloren!')"
                       href="?kPlugin={$oPlugin->kPlugin}&action=reset&setting=customCSS" class="btn btn-danger">zurcksetzen</a>
                </form>

            </div>
        </div>
    </div>

    <!-- Facets -->
    <div class="panel panel-default">
        <div class="panel-heading" role="tab" id="facetsH">
            <h4 class="panel-title">
                <a role="button" data-toggle="collapse" data-parent="#accordion" href="#facets"
                   aria-expanded="false" aria-controls="facets">
                    Facets
                </a>
            </h4>
        </div>
        <div id="facets" class="panel-collapse collapse" role="tabpanel" aria-labelledby="facetsH">
            <div class="panel-body">

                <a href="plugin.php?kPlugin={$oPlugin->kPlugin}&action=updatefacets" class="btn btn-primary right">Aktualisieren</a>

                <table class="table table-striped table-condensed">
                    <thead>
                    <tr>
                        <th>Hash</th>
                        <th>Type</th>
                        <th>Name</th>
                        <th>Label</th>
                        <th>Size</th>
                        <th>Sort</th>
                    </tr>
                    </thead>
                    <tbody>
                    {if isset($facets)}
                        {foreach from=$facets item=hashfacets key=hash}
                            {foreach from=$hashfacets item=facet}
                                <tr>
                                    <td>{$hash}</td>
                                    <td>{$facet->type}</td>
                                    <td>{$facet->name}</td>
                                    <td>{$facet->label}</td>
                                    <td>{$facet->size}</td>
                                    <td>{$facet->sort}</td>
                                </tr>
                            {/foreach}
                            <tr>
                                <td colspan="6">&nbsp;</td>
                            </tr>
                        {/foreach}
                    {/if}
                    </tbody>
                </table>


            </div>
        </div>
    </div>

</div>
<script>
    history.replaceState(null, "JTL-Shop / dooFinder", 'plugin.php?kPlugin={$oPlugin->kPlugin}');
</script>