<div id="sync-progress" style="display: none;">
    <h3>Synchronisation</h3>
    <div class="progress">
        <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="0"
             aria-valuemin="0"
             aria-valuemax="100"
             style="min-width: 2em; width: 0%;">
            0%
        </div>
    </div>
    <ul class="log"></ul>
</div>


<script type="application/javascript">
    // <!--
    $(function () {

        var cancel = [];
        var startTime = 0;

        var startSync = function (sprache, waehrung, kundengruppe) {
            $(".show-on-export-" + sprache + waehrung + kundengruppe).show();
            $(".hide-on-export-" + sprache + waehrung + kundengruppe).hide();
            $(".sync-feed").attr("disabled", true);
            $(".sync-feed-" + sprache + waehrung + kundengruppe + " .fa").addClass("fa-spin");
            $('#sync-progress').show();
            $('#sync-progress .log').html('');
            var bar = $('#sync-progress .progress-bar')
            bar.addClass('active');
            setProgress(0, 0);
            startTime = (new Date()).getTime();
        };

        var addLog = function (message) {
            $('#sync-progress .log').prepend('<li>[' + ((new Date()).getTime() - startTime) + "] " + message + '</li>');
        }

        var stopSync = function (sprache, waehrung, kundengruppe) {
            $(".hide-on-export-" + sprache + waehrung + kundengruppe).show();
            $(".show-on-export-" + sprache + waehrung + kundengruppe).hide();
            $(".sync-feed").attr("disabled", false);
            $(".sync-feed-" + sprache + waehrung + kundengruppe + " .fa").removeClass("fa-spin");
            $(".show-on-export-" + sprache + waehrung + kundengruppe + " .cancel-feed").attr('disabled', false);
        };

        var setProgress = function (current, total) {
            var pc = total > 0 ? Math.floor((current / total) * 100) : 0;
            var bar = $('#sync-progress .progress-bar');
            pc = pc > 100 ? 100 : pc;
            if (pc === 100) {
                bar.removeClass('active');
            }
            bar.css("width", pc + "%")
                .text(pc + "% - " + current + " von " + total);
        };

        var showError = function (message, type, append) {

            var alert = $('#feeds-alert');
            var _html = alert.html();
            message = '<p>' + message + '</p>';
            alert.removeClass()
                .addClass('alert').addClass("alert-" + type)
                .html(append ? _html + message : message);
        };

        var doSync = function (sprache, waehrung, kundengruppe) {

            var ignoreErrors = $('#ignoreErrors_' + sprache + waehrung + kundengruppe).is(':checked');

            var target = "{"http:"|str_replace:"":$oPlugin->cAdminmenuPfadURL}ajax/api.php?action=sync&kSprache=" + sprache + "&kWaehrung=" + waehrung + "&kKundengruppe=" + kundengruppe + "&token={$ajaxToken}";
            $.ajax(target, {
                error: function (jqXHR, textStatus, errorThrown) {
                    showError('Fehler: ' + textStatus + "<br/><pre>" + errorThrown + "</pre>", "danger", ignoreErrors);
                    stopSync(sprache, waehrung, kundengruppe);
                },
                success: function (data, textStatus, jqXHR) {
                    if (data.status === 'error') {
                        showError('Fehler: ' + data.message, "danger", ignoreErrors);
                        if (ignoreErrors) {
                            setProgress(data.start, data.total);
                            doSync(sprache, waehrung, kundengruppe);
                        }
                    } else if (data.status === 'ok') {
                        if (cancel[sprache + waehrung + kundengruppe] === true) {
                            showError("Export wurde abgebrochen!", "warning", false);
                            stopSync(sprache, waehrung, kundengruppe);
                            cancel[sprache + waehrung + kundengruppe] = false;
                        } else {
                            setProgress(data.start + data.limit, data.total);
                            doSync(sprache, waehrung, kundengruppe);
                        }
                    } else if (data.status === 'complete') {
                        showError("Es wurden " + data.total + " Produkte erfolgreich bertragen.", "success", false);
                        stopSync(sprache, waehrung, kundengruppe);
                        setProgress(data.total, data.total);
                    }
                    if (data.message && data.message !== true) {
                        addLog(data.message);
                    }
                },
                complete: function () {

                }
            });
        };

        $('.cancel-feed').on('click', function () {
            var waehrung = $(this).data('waehrung');
            var kundengruppe = $(this).data('kundengruppe');
            var sprache = $(this).data('sprache');

            cancel[sprache + waehrung + kundengruppe] = true;
            $(this).attr('disabled', true);
        });

        $('.sync-feed').on('click', function () {

            var waehrung = $(this).data('waehrung');
            var kundengruppe = $(this).data('kundengruppe');
            var sprache = $(this).data('sprache');

            if (!sprache || sprache === "" || !waehrung || waehrung === "" || !kundengruppe || kundengruppe === "") {
                showError('Konfiguration fehlerhaft!', 'danger', false);
                return false;
            }

            startSync(sprache, waehrung, kundengruppe);
            doSync(sprache, waehrung, kundengruppe);

            return false;
        });

    });
    // -->
</script>