<div>
    <h3>URLs</h3>

    <p><label>
            <input type="checkbox" id="checkCron"/> Cronjob
        </label>
        - <label>
            <input type="checkbox" checked="checked" id="checkWebCron"/>
            WebRequest
        </label>
    </p>

    <h4 style="margin-top: 25px">ReIndex URL</h4>
    <div class="urls">
        <p>Auf diese URL kann ein Cronjob eingerichtet werden. Zusammen mit der <code>DOOFINDER_MIN_REINDEX</code>
            knnen die API Request somit optimal ausgenutzt werden. Hierber werden die Artikel in der ReIndex Tabelle
            an dooFinder bertragen.</p>
        <pre class="webrequest">{$syncURL}?action=reindex{if $exportSecret}&secret={$exportSecret}{/if}</pre>
        <pre class="cronjob" style="display: none"><abbr title="Alle 10 Minuten" style="display: none"
                                                         class="cronjob_attr">*/10 * * * *</abbr> <abbr
                    title="Pfad zur PHP Binary">php</abbr> {$pluginPfad}/sync.php reindex</span></pre>
    </div>

    <h4 style="margin-top: 25px">Export URL</h4>
    <div class="urls">
        <p>Auf diese URL kann ein Cronjob eingerichtet werden. Zusammen mit der <code>DOOFINDER_CRON_DIFF</code>
            Konstante knnen so auch Export-Dateien fr den Abruf durch dooFinder erstellt werden.</p>
        <p style="display: none" class="cronjob">Hilfe fr <a href="https://crontab.guru/#*/10_*_*_*_*" target="_blank">Cronjob
                Zeitplan</a>.</p>

        {foreach name=Exportformat from=$oConfigs item=oConfig}
            <h5>{$oConfig->getSprache(true)->cNameDeutsch} / {$oConfig->getWaehrung(true)->cName}
                / {$oConfig->getKundengruppe(true)->getName()}</h5>
            <pre class="webrequest">{$syncURL}?action=export&hashid={$oConfig->getHashID()}{if $exportSecret}&secret={$exportSecret}{/if}<span
                        class="cronjob_attr" style="display:none;">&cron=1</span></pre>
            <pre class="cronjob" style="display: none"><abbr title="Alle 10 Minuten" style="display: none"
                                                             class="cronjob_attr">*/10 * * * *</abbr> <abbr
                        title="Pfad zur PHP Binary">php</abbr> {$pluginPfad}/sync.php export {$oConfig->getHashID()}<span
                        class="cronjob_attr" style="display:none;"> 1</span></span></pre>
            <h6>Export-Datei</h6>
            <pre>{$URL_SHOP}/{$smarty.const.PFAD_EXPORT}{$oConfig->getExportFilename()}</pre>
            <hr/>
        {/foreach}
    </div>

    <h4 style="margin-top: 25px">Paginated-Feed</h4>
    <div class="urls">
        <p>URL fr den paginatedFeed, muss durch dooFinder Support aktiviert werden.</p>
        {foreach from=$oConfigs item=oConfig}
            <h5>{$oConfig->getSprache(true)->cNameDeutsch} / {$oConfig->getWaehrung(true)->cName}
                / {$oConfig->getKundengruppe(true)->getName()}</h5>
            <pre>{$exportURL}?id={$oConfig->getHashID()}{if $exportSecret}&secret={$exportSecret}{/if}</pre>
        {/foreach}
    </div>

    <h4 style="margin-top: 25px">Seiten-Feed</h4>
    <div class="urls">
        <p>Beinhaltet Daten ber die Shop Seiten, kann ber den <code>export</code>-Parameter (Array) nher spezifiziert
            werden. (<code>brands</code>, <code>news</code>, <code>categories</code>, <code>links</code>).</p>
        {foreach from=$oConfigs item=oConfig}
            <pre>{$pagesURL}?id={$oConfig->getHashID()}</pre>
        {/foreach}
    </div>

</div>

<script type="application/javascript">
    // <!--
    $(function () {

        // URLs & CRONJOBs

        $(document).on('change', '#checkCron', function () {
            if ($(this).prop('checked')) {
                $('.cronjob_attr').show();
            } else {
                $('.cronjob_attr').hide();
            }
        });

        $(document).on('change', '#checkWebCron', function () {
            if ($(this).prop('checked')) {
                $('.webrequest').show();
                $('.cronjob').hide();
            } else {
                $('.webrequest').hide();
                $('.cronjob').show();
            }
        });
    });
    // -->
</script>