CREATE TABLE IF NOT EXISTS `xplugin_jst_doofinder_searchengines` (
    `kSprache`             int         NOT NULL,
    `kKundengruppe`        int         NOT NULL,
    `kWaehrung`            int         NOT NULL,
    `cHashID`              varchar(32) NOT NULL,
    `kKampagne`            int         NOT NULL,
    `bCache`               tinyint(1)  NOT NULL,
    `nVarKombiOption`      tinyint(2)  NOT NULL,
    `nOnlyStorage`         tinyint(2)  NOT NULL,
    `bPositivePrice`       tinyint(1)  NOT NULL,
    `bOnlyWithDescription` tinyint(1)  NOT NULL,
    `bShowChildsNative`    tinyint(1)  NOT NULL,
    `bEnabledLayer`        tinyint(1)  NOT NULL DEFAULT 0,
    `bEnabledNative`       tinyint(1)  NOT NULL DEFAULT 0
);

ALTER TABLE `xplugin_jst_doofinder_searchengines`
    ADD PRIMARY KEY `kSprache_kKundengruppe_kWaehrung` (`kSprache`, `kKundengruppe`, `kWaehrung`);



UPDATE `xplugin_jst_doofinder_settings` SET
    `dModified` = now(),
    `cDefault` = '<script type=\'text/x-mustache-template\' id=\'df-results-template\'>\r\n{{#is_first}}\r\n  {{#banner}}\r\n    <div class=\"df-banner\">\r\n      <a {{#blank}}target=\"_blank\" rel=\"noopener noreferer\"{{/blank}} href=\"{{link}}\" data-role=\"banner\" data-banner=\"{{id}}\">\r\n        {{#image}}\r\n        <img src=\"{{#remove-protocol}}{{image}}{{/remove-protocol}}\">\r\n        {{/image}}\r\n        {{#html_code}}\r\n        {{{html_code}}}\r\n        {{/html_code}}\r\n      </a>\r\n    </div>\r\n  {{/banner}}\r\n{{/is_first}}\r\n{{#total}}\r\n  {{#results}}\r\n    <div class=\"df-card\" data-role=\"result\">\r\n      <a class=\"df-card__main\" href=\"{{#url-params}}{{{link}}}{{/url-params}}\" data-role=\"result-link\" data-dfid=\"{{dfid}}\">\r\n        {{#image_link}}\r\n          <figure class=\"df-card__image\">\r\n            <img src=\"{{#remove-protocol}}{{image_link}}{{/remove-protocol}}\" alt=\"{{title}}\">\r\n          </figure>\r\n        {{/image_link}}\r\n        <div class=\"df-card__content\">\r\n          <div class=\"df-card__title\">{{title}}</div>\r\n          <div class=\"df-card__description\">{{{description}}}</div>\r\n          {{#price}}\r\n          <div class=\"df-card__pricing\">\r\n            <span class=\"df-card__price {{#sale_price}}df-card__price--old{{/sale_price}}\">\r\n              {{#format-currency}}{{price}}{{/format-currency}}\r\n            </span>\r\n            {{#sale_price}}\r\n              <span class=\"df-card__price df-card__price--new\">\r\n                {{#format-currency}}{{sale_price}}{{/format-currency}}\r\n              </span>\r\n            {{/sale_price}}\r\n          </div>\r\n          {{/price}}\r\n          {{#df_rating}}\r\n          <div>\r\n            <div class=\"df-rating\" title=\"{{df_rating}}\">\r\n              <div class=\"df-rating__value\" style=\"width: {{#rating-percent}}{{df_rating}}{{/rating-percent}}\">\r\n                <i>&#9733;</i><i>&#9733;</i><i>&#9733;</i><i>&#9733;</i><i>&#9733;</i>\r\n              </div>\r\n              <div class=\"df-rating__placeholder\">\r\n                <i>&#9733;</i><i>&#9733;</i><i>&#9733;</i><i>&#9733;</i><i>&#9733;</i>\r\n              </div>\r\n            </div>\r\n          </div>\r\n          {{/df_rating}}\r\n        </div>\r\n      </a>\r\n    </div>\r\n  {{/results}}\r\n{{/total}}\r\n{{^total}}\r\n  {{#noResultsHTML}}{{{noResultsHTML}}}{{/noResultsHTML}}\r\n  {{^noResultsHTML}}\r\n    <p class=\"df-no-results\">{{#translate}}Sorry, no results found.{{/translate}}</p>\r\n  {{/noResultsHTML}}\r\n{{/total}}\r\n</script>\r\n'
WHERE `kSetting` = 'customTPL';


ALTER TABLE `xplugin_jst_doofinder_sync`
    ADD `dLastSync` datetime NULL,
    ADD `cChecksum` varchar(32) NULL AFTER `dLastSync`;


CREATE TABLE `xplugin_jst_doofinder_sesync` (
    `cHashID` varchar(32) NOT NULL,
    `nLast`   int         NOT NULL,
    `dLast`   datetime    NOT NULL
);

ALTER TABLE `xplugin_jst_doofinder_sesync`
    ADD PRIMARY KEY `cHashID` (`cHashID`);

CREATE TABLE IF NOT EXISTS `xplugin_jst_doofinder_product` (
    `cKey`      varchar(100) NOT NULL,
    `cDefault`  text         NOT NULL,
    `cCustom`   text         NULL,
    `dModified` datetime     NULL,
    `cError`    text         NULL
);

ALTER TABLE `xplugin_jst_doofinder_product`
    ADD PRIMARY KEY `cKey` (`cKey`);

INSERT INTO `xplugin_jst_doofinder_product` (`cKey`, `cDefault`, `cCustom`, `dModified`, `cError`) VALUES
('additional_image_link',	'if(count($this->oArtikel->Bilder) > 1){\r\n $exportImgSize = \\jst_doofinder\\Helper::getSetting(\'exportImgSize\') ?:\'cPfadNormal\';\r\n $imgs = [];\r\n foreach($this->oArtikel->Bilder as $i => $val){\r\n if($i === 0) continue;\r\n $imgs[] = \\Shop::getURL() . \'/\' . $this->oArtikel->Bilder[$i]->$exportImgSize;\r\n }\r\n return $imgs;\r\n}\r\n\r\nreturn null;',	NULL,	NULL,	NULL),
('article_no',	'return $this->oArtikel->cArtNr;',	NULL,	NULL,	NULL),
('attributes',	'$multi = new DFMultiple();\r\n\r\nforeach ($this->oArtikel->AttributeAssoc as $key => $value) {\r\n if (in_array(strtolower($key), self::getAttr())) {\r\n $canonical = trim(DFHelper::getSetting(\'prefixAttribute\')) . self::getSlugify()->slugify(utf8_encode($key));\r\n $multi->addMultiple($value, $canonical);\r\n }\r\n}\r\n\r\nreturn $multi;',	NULL,	NULL,	NULL),
('availability',	'$multi = new DFMultiple();\r\n\r\n\r\n$multi->availability = \'in stock\';\r\nif ($this->oArtikel->cLagerBeachten === \'Y\' && $this->oArtikel->cLagerKleinerNull === \'N\' && $this->oArtikel->fLagerbestand <= 0) {\r\n $multi->availability = \'out of stock\';\r\n}\r\n\r\n$multi->availability_label = $multi->availability === \'in stock\' ? DFHelper::oPlugin()->oPluginSprachvariableAssoc_arr[\'in_stock\'] : DFHelper::oPlugin()->oPluginSprachvariableAssoc_arr[\'out_of_stock\'];\r\n\r\nreturn $multi;',	NULL,	NULL,	NULL),
('base_price_localized',	'return $this->oArtikel->cLocalizedVPE ?: null;',	NULL,	NULL,	NULL),
('bestseller',	'return (bool)$this->oArtikel->bIsBestseller;',	NULL,	NULL,	NULL),
('df_manual_boost',	'return \\jst_doofinder\\Backend::getArtikelBoost($this->oArtikel);',	NULL,	NULL,	NULL),
('brand',	'return trim($this->oArtikel->cHersteller) ?: null;',	NULL,	NULL,	NULL),
('categories',	'$level = \\jst_doofinder\\Helper::getSetting(\'it_CatLevel\');\r\n$nCount = 0;\r\n$cCategorie_arr = [];\r\nif (count($this->oArtikel->oKategorie_arr) > 0) {\r\n foreach ($this->oArtikel->oKategorie_arr as $oCategorie) {\r\n if (is_int($oCategorie)) {\r\n $oCategorie = new \\Kategorie($oCategorie, $this->config->getSprache(), $this->config->getKundengruppe());\r\n }\r\n if ($level === \'A\') {\r\n $cCategorie_arr[] = $oCategorie->cKategoriePfad;\r\n } else {\r\n $cCategorie_arr[] = implode(\' > \', array_slice($oCategorie->cKategoriePfad_arr, 0, (int)$level));\r\n }\r\n if ($nCount++ >= 10) {\r\n break;\r\n }\r\n }\r\n}\r\n\r\nreturn array_unique($cCategorie_arr);',	NULL,	NULL,	NULL),
('category_levels',	'if (DFHelper::getSetting(\'exportCatLevel\') === \'Y\') {\n $multiple = new DFMultiple();\n\n $level = (int)DFHelper::getSetting(\'it_CatLevel\') > 0 ? (int)DFHelper::getSetting(\'it_CatLevel\') : INF;\n $result = [];\n\n if (count($this->oArtikel->oKategorie_arr) > 0) {\n foreach ($this->oArtikel->oKategorie_arr as $oCategorie) {\n $nCount = 0;\n if (is_int($oCategorie)) {\n $oCategorie = new \\Kategorie($oCategorie, $this->config->getSprache(), $this->config->getKundengruppe());\n }\n $cats = array_values($oCategorie->cKategoriePfad_arr);\n while (($cat = array_shift($cats)) && $nCount < $level) {\n $key = \'cat_lvl_\' . $nCount++;\n if (!array_key_exists($key, $result) || !is_array($result[$key])) {\n $result[$key] = [];\n }\n $result[$key][] = $cat;\n }\n }\n }\n if (count($result)) {\n foreach ($result as $key => $vals) {\n $multiple->$key = array_values(array_unique($vals));\n }\n }\n\n return $multiple;\n}\nreturn null;',	NULL,	NULL,	NULL),
('description',	'return self::formatText($this->oArtikel->cBeschreibung);',	NULL,	NULL,	NULL),
('df_rating',	'return $this->oArtikel->Bewertungen !== null && (float)$this->oArtikel->fDurchschnittsBewertung > 0 ? (float)$this->oArtikel->fDurchschnittsBewertung : null;',	NULL,	NULL,	NULL),
('fkt_attributes',	'$multi = new DFMultiple();\n\nforeach ($this->oArtikel->FunktionsAttribute as $key => $value) {\n if (in_array(strtolower($key), self::getFktAttr())) {\n   $canonical = trim(DFHelper::getSetting(\'prefixFktAttribute\')) . self::getSlugify()->slugify(utf8_encode($key));\n   $multi->$canonical = $value;\n }\n}\n\nreturn $multi;',	NULL,	NULL,	NULL),
('group_id',	'if ($this->oArtikel->kVaterArtikel > 0) {\r\n return $this->oArtikel->kVaterArtikel;\r\n}\r\nreturn null;',	NULL,	NULL,	NULL),
('gtin',	'return trim($this->oArtikel->cBarcode) ?: null;',	NULL,	NULL,	NULL),
('image_link',	'$exportImgSize = \\jst_doofinder\\Helper::getSetting(\'exportImgSize\') ?:\'cPfadNormal\';\r\n\r\nif(count($this->oArtikel->Bilder)){\r\n return \\Shop::getURL() . \'/\' . $this->oArtikel->Bilder[0]->$exportImgSize;\r\n}\r\nreturn null;',	NULL,	NULL,	NULL),
('indexed_text',	'return $this->getIndexedText();',	NULL,	NULL,	NULL),
('isbn',	'return trim($this->oArtikel->cISBN) ?: null;',	NULL,	NULL,	NULL),
('is_bundle',	'return $this->oArtikel->kStueckliste > 0;',	NULL,	NULL,	NULL),
('kartikel',	'return $this->oArtikel->kArtikel;',	NULL,	NULL,	NULL),
('link',	'$link = \\Shop::getURL() . \'/\' . $this->oArtikel->cURL;\r\nif ($kampagne = $this->config->getKampagne(true)) {\r\n $cSep = \'?\';\r\n if (strpos($link, \'?\') !== false) {\r\n $cSep = \'&\';\r\n }\r\n $link .= $cSep . $kampagne->cParameter . \'=\' . ($kampagne->nDynamisch == 1 ? $this->config->getHashID() : $kampagne->cWert);\r\n}\r\nreturn $link;',	NULL,	NULL,	NULL),
('merkmale',	'$multi = new DFMultiple();\r\n\r\n$oMerkmale_arr = $this->oArtikel->oMerkmale_arr;\r\nif ($this->oArtikel->kVaterArtikel && strlen(trim(DFHelper::getSetting(\'combineFilteredMekmale\'))) && $oFilterMerkmale = $this->getFilteredMerkmale()) {\r\n $oVater = new Artikel();\r\n $oVater->fuelleArtikel($this->oArtikel->kVaterArtikel, $this->options);\r\n if ($oVater->kArtikel) {\r\n foreach ($oVater->oMerkmale_arr as $oMerkmal) {\r\n if (array_key_exists($oMerkmal->kMerkmal, $oMerkmale_arr)) {\r\n $oMerkmale_arr[$oMerkmal->kMerkmal] = $oMerkmal;\r\n }\r\n }\r\n }\r\n}\r\n\r\n/** @var Merkmal $oMerkmal */\r\nforeach ($oMerkmale_arr as $oMerkmal) {\r\n $mappedName = trim(DFHelper::getSetting(\'prefixMerkmal\')) . self::getMappedKey($oMerkmal->cName);\r\n /** @var MerkmalWert $oMerkmalWert */\r\n foreach ($oMerkmal->oMerkmalWert_arr as $oMerkmalWert) {\r\n $mappedValues = self::getMappedValue($oMerkmalWert->cWert);\r\n $multi->addMultiple($mappedValues, $mappedName);\r\n }\r\n}\r\nreturn $multi;',	NULL,	NULL,	NULL),
('mpn',	'return trim($this->oArtikel->cHAN) ?: null;',	NULL,	NULL,	NULL),
('new_article',	'return $this->oArtikel->cNeu === \'Y\';',	NULL,	NULL,	NULL),
('overbuy',	'return $this->oArtikel->cLagerBeachten === \'N\' || $this->oArtikel->cLagerKleinerNull === \'Y\' ? true : false;',	NULL,	NULL,	NULL),
('price',	'$multi = new DFMultiple();\r\n\r\n\r\n$multi->price = $this->oArtikel->Preise->fVKBrutto > 0\r\n ? $this->formatPrice($this->oArtikel->Preise->fVK[$this->config->getKundengruppe(true)->getNettoPreise()])\r\n : 0;\r\n\r\nif ($this->oArtikel->Preise->alterVKNetto) {\r\n $multi->sale_price = $multi->price;\r\n $multi->price = $this->oArtikel->Preise->alterVKLocalized ? $this->formatPrice($this->oArtikel->Preise->alterVK[$this->config->getKundengruppe(true)->getNettoPreise()]) : null;\r\n}\r\n\r\nif (DFHelper::getSetting(\'it_uvp\') === \'Y\' && $this->oArtikel->fUVP > $this->oArtikel->Preise->fVKBrutto) {\r\n $multi->sale_price = $this->oArtikel->Preise->fVKBrutto > 0 ? $this->formatPrice($this->oArtikel->Preise->fVK[$this->config->getKundengruppe(true)->getNettoPreise()]) : Sprache::getInstance()->get(\'priceOnApplication\');\r\n $multi->price = $this->formatPrice($this->oArtikel->fUVP);\r\n if ($multi->oArtikel->Preise->alterVKNetto && $this->oArtikel->Preise->alterVKNetto < $this->oArtikel->fUVP) {\r\n $multi->price = $this->oArtikel->Preise->alterVKLocalized ? $this->formatPrice($this->oArtikel->Preise->alterVK[$this->config->getKundengruppe(true)->getNettoPreise()]) : null;\r\n }\r\n}\r\n\r\n\r\n$multi->pricePrefix = null;\r\nif (($this->oArtikel->nVariationsAufpreisVorhanden == 1 || $this->oArtikel->bHasKonfig) && $this->oArtikel->kVaterArtikel == 0) {\r\n $multi->pricePrefix = \\Sprache::getInstance()->get(\'priceStarting\', \'global\');\r\n} elseif ($this->oArtikel->Preise->rabatt > 0 || $this->oArtikel->Preise->alterVKNetto > $this->oArtikel->Preise->fVKNetto) {\r\n $multi->pricePrefix = \\Sprache::getInstance()->get(\'nowOnly\', \'global\');\r\n}\r\nif (isset($this->oArtikel->Preise->fStaffelpreis_arr) && count($this->oArtikel->Preise->fStaffelpreis_arr)) {\r\n $multi->pricePrefix = \\Sprache::getInstance()->get(\'priceStarting\', \'global\');\r\n $multi->minPrice = $this->formatPrice(end($this->oArtikel->Preise->fStaffelpreis_arr)[$this->config->getKundengruppe(true)->getNettoPreise()]);\r\n $multi->minPriceLocalized = gibPreisStringLocalized(end($this->oArtikel->Preise->fStaffelpreis_arr)[$this->config->getKundengruppe(true)->getNettoPreise()], $this->config->getWaehrung(true));\r\n}\r\n\r\nreturn $multi;',	NULL,	NULL,	NULL),
('rating_count',	'return $this->oArtikel->Bewertungen !== null && (float)$this->oArtikel->fDurchschnittsBewertung > 0 ? (int)$this->oArtikel->Bewertungen->oBewertungGesamt->nAnzahl : null;',	NULL,	NULL,	NULL),
('shipping_weight',	'return (float)$this->oArtikel->fGewicht ?: null;',	NULL,	NULL,	NULL),
('short_description',	'return self::formatText($this->oArtikel->cKurzBeschreibung);',	NULL,	NULL,	NULL),
('stock',	'if ($this->oArtikel->cLagerBeachten === \'Y\' && $this->oArtikel->cLagerKleinerNull === \'N\') {\r\n return (float)$this->oArtikel->fLagerbestand;\r\n}\r\nreturn null;',	NULL,	NULL,	NULL),
('title',	'$name = $this->oArtikel->cName;\r\n\r\nif (\\jst_doofinder\\Helper::getSetting(\'exportParentName\') === \'Y\' && (int)$this->oArtikel->kVaterArtikel > 0) {\r\n $name = $this->getVater(\'cName\');\r\n}\r\n\r\nif((defined(\'JTL_MINOR_VERSION\') && (int)JTL_MINOR_VERSION >= 16) || \\Shop::getSettingValue(CONF_GLOBAL, \'global_artikelname_htmlentities\') === \'Y\'){\r\n return \\StringHandler::unhtmlentities($name);\r\n}\r\n\r\nreturn $name;',	NULL,	NULL,	NULL),
('top_article',	'return $this->oArtikel->cTopArtikel === \'Y\';',	NULL,	NULL,	NULL),
('ust',	'return (float)$this->oArtikel->Preise->fUst;',	NULL,	NULL,	NULL),
('uvp',	'return (float)$this->oArtikel->fUVP > 0 ? (float)(float)$this->oArtikel->fUVP : null;',	NULL,	NULL,	NULL),
('uvp_localized',	'return (float)$this->oArtikel->fUVP > 0 ? $this->oArtikel->cUVPLocalized : null;',	NULL,	NULL,	NULL),
('variations',	'$multi = new DFMultiple();\r\n\r\n$Variationen = null;\r\nif ($this->oArtikel->nIstVater > 0) {\r\n $Variationen = $this->oArtikel->VariationenOhneFreifeld;\r\n} elseif ($this->oArtikel->kVaterArtikel > 0) {\r\n $Variationen = $this->oArtikel->oVariationenNurKind_arr;\r\n}\r\n\r\n$lagerbeachten = $this->config->getOnlyStorage() !== \'N\';\r\n\r\nif ($Variationen) {\r\n foreach ($Variationen as $oVariation) {\r\n if (false !== stripos($oVariation->cTyp, \'FREITEXT\')) {\r\n continue;\r\n }\r\n $Werte = $oVariation->Werte;\r\n if (in_array($oVariation->kEigenschaft, self::getExcludeedVariations())) {\r\n foreach ($this->oArtikel->VariationenOhneFreifeld as $VariationOF) {\r\n if ($VariationOF->kEigenschaft === $oVariation->kEigenschaft) {\r\n $Werte = array_filter($VariationOF->Werte, function ($Wert) use ($lagerbeachten) {\r\n $stock = isset($Wert->oVariationsKombi) && $Wert->oVariationsKombi->cLagerBeachten === \'Y\' ? (int)$Wert->oVariationsKombi->tartikel_fLagerbestand : (int)$Wert->fLagerbestand;\r\n return !(int)$Wert->nNichtLieferbar && (($lagerbeachten && $stock > 0) || !$lagerbeachten);\r\n });\r\n break;\r\n }\r\n }\r\n }\r\n\r\n $mappedName = trim(DFHelper::getSetting(\'prefixVariation\')) . self::getMappedKey($oVariation->cName);\r\n foreach ($Werte as $oWert) {\r\n $mappedValues = self::getMappedValue($oWert->cName);\r\n $multi->addMultiple($mappedValues, $mappedName);\r\n }\r\n }\r\n}\r\n\r\nreturn $multi;',	NULL,	NULL,	NULL);
